# Othello
### COMS 4995 Parallel Functional Programming Final Project
### Noam Hirschorn (nyh2111) & Dan Ivanovich (dmi2115) 

Our experiments in parallelizing the performance of an Othello minmax agent. Adapted from [this codebase](https://arttuys.fi/coding/2022/05/othello-haskell/).

## Building 
This project uses `cabal`. To compile the code, simply run `cabal build` from the root directory (`.` in the file listing)

By default, this will build side_side9.hs, the parMap-based Parallelization. To build another file, update the following lin in hello-othello.cabal:
```
executable othello
    main-is:          side_side_9.hs  <-- Change this file name 
```
and then run `cabal build` again.
## Running
After running `cabal build`, run using `cabal run othello -- <how deep search tree should go> <what depth to start parallization at> <gameboard file> +RTS -N<number of threads> -s`. 

Example:
```
$ cabal build
Resolving dependencies...
<Output Truncated For Brevity>

$ cabal run othello -- 5 4 custom_game_2.txt +RTS -N8 -s
Using minimax depth: 5
Parallelizing at depth: 4
Next move: (5,2)
<Output Truncated For Brevity>
```

Some suggested test case parameters:
* `cabal run othello -- 5 4 custom_game_2.txt +RTS -N3 -s`
* `cabal run othello -- 5 4 custom_game_2.txt +RTS -N6 -s`
* `cabal run othello -- 6 5 custom_game_2.txt +RTS -N3 -s`
* `cabal run othello -- 6 5 custom_game_2.txt +RTS -N6 -s`

## File Listing
```
.
├── app
│   ├── Main_side_side.hs
│   ├── Main_top_down.hs
│   ├── side_side_3.hs
│   ├── side_side_4.hs
│   ├── side_side_5.hs
│   ├── side_side_6.hs
│   ├── side_side_7.hs    # One of our two best performers - parBuffer-based Parallelization
│   ├── side_side_8.hs
│   └── side_side_9.hs    # One of our two best performers - parMap-based Parallelization
├── benchmark_performance.py  # Performance benchmarking script, can run with --help for info 
├── cabal.project
├── custom_game_1.txt     # A starting board with only a few possible moves
├── custom_game_2.txt     # A starting board with far more possible moves
├── haskell-othello.cabal # Adjust to pick which of the files in /app to build & run
├── README.md             # This file
└── src
    └── Othello
        ├── backup_Gamelog.hs
        └── GameLogic.hs
```
